<template>
    <section class="hero is-light is-fullheight">
        <div class="hero-body">
            <div class="container has-text-centered">
                <div class="column is-4 is-offset-4">
                    <h3 class="title has-text-black">Login</h3>
                    <div class="box">
                        <form @submit.prevent="recaptcha('execute')" @keyup.enter="recaptcha('execute')">
                            <b-field label="Username">
                                <b-input v-model="username"></b-input>
                            </b-field>
                            <b-field label="Password">
                                <b-input type="password" v-model="password" password-reveal></b-input>
                            </b-field>
                            <vue-recaptcha
                                :sitekey="recaptchaKey"
                                @verify="recaptcha('verify', $event)"
                                @expired="recaptcha('expired', null)"
                                @error="recaptcha('error', null)"
                                ref="recaptcha"
                                size="invisible"
                            >
                                <b-button type="is-primary" @click="recaptcha">Log in</b-button>
                            </vue-recaptcha>
                        </form>
                    </div>
                    <p class="block has-text-grey">
                        <router-link to="/register">Don't have an account?</router-link>
                    </p>
                    <p class="block has-text-grey" @click="isForgotPasswordModalActive = true">
                        <a>Forgot your password?</a>
                    </p>
                </div>
            </div>
        </div>
        <b-modal v-model="isForgotPasswordModalActive">
            <div class="card">
                <div class="card-content">
                    <p class="block">
                        If you forgot your password, please enter your username
                        and the email address you signed up with below. If we have a
                        matching record, an email will be sent to the address on
                        file with a temporary password.
                    </p>
                    <b-field label="Username" custom-class="modal-card-body">
                        <b-input v-model="forgotPasswordUsername"></b-input>
                    </b-field>
                    <b-field label="Email" custom-class="modal-card-body">
                        <b-input v-model="forgotPasswordEmail"></b-input>
                    </b-field>
                    <b-button type="is-primary" @click="resetPassword">
                        Reset Password
                    </b-button>
                </div>
            </div>
        </b-modal>
    </section>
</template>

<script>
 import VueRecaptcha from 'vue-recaptcha'
 export default {
     name: 'Login',
     components: { 'vue-recaptcha': VueRecaptcha },
     data() {
         return {
             username: '',
             password: '',
             recaptchaKey: process.env.VUE_APP_RECAPTCHA_SITE_KEY,
             isForgotPasswordModalActive: false,
             forgotPasswordUsername: '',
             forgotPasswordEmail: ''
         }
     },
     methods: {
         recaptcha(event, token) {
             if (event === 'verify') {
                 this.$refs.recaptcha.reset()
                 this.login(token)
             } else if (event === 'expired') {
                 this.$refs.recaptcha.reset()
             } else if (event === 'error') {
                 this.$buefy.toast.open({
                     duration: 3000,
                     message: "Something went wrong with the Captcha",
                     position: "is-bottom",
                     type: "is-danger",
                     queue: false
                 })
                 this.$refs.recaptcha.reset()
             } else if (event === 'execute') {
                 this.$refs.recaptcha.execute()
             }
         },
         login(recaptchaToken) {
             fetch('/api/user/login', {
                 method: 'POST',
                 headers: {
                     'Content-Type': 'application/json;charset=utf-8'
                 },
                 body: JSON.stringify({
                     username: this.username,
                     password: this.password,
                     recaptchaToken: recaptchaToken
                 })
             }).then((response) => {
                 if (response.ok) {
                     this.$router.push('/contestant-portal')
                     this.$emit('login')
                 } else if (response.status === 429) {
                     // rate limit hit
                     this.$refs.recaptcha.reset()
                     this.$buefy.toast.open({
                         duration: 3000,
                         message: "You've made too many requests. Please try again later",
                         position: 'is-bottom',
                         type: 'is-danger',
                         queue: false
                     })
                 } else if (response.status === 401) {
                     // not authorized
                     this.$refs.recaptcha.reset()
                     this.$buefy.toast.open({
                         duration: 3000,
                         message: "Cannot log in with those credentials",
                         position: "is-bottom",
                         type: "is-danger",
                         queue: false
                     })
                 } else {
                     this.$refs.recaptcha.reset()
                     this.$buefy.toast.open({
                         duration: 3000,
                         message: "Something went wrong",
                         position: 'is-bottom',
                         type: 'is-danger',
                         queue: false
                     })
                 }
             }).catch((e) => {
                 this.$refs.recaptcha.reset()
                 // server error
                 console.error(e)
             })
         },
         resetPassword() {
             if (!this.forgotPasswordUsername || !this.forgotPasswordEmail) {
                 this.$buefy.toast.open({
                     duration: 3000,
                     message: "Please enter both your username and email",
                     position: 'is-bottom',
                     type: 'is-warning',
                     queue: false
                 });
             }
             fetch('/api/user/resetpassword', {
                 method: 'POST',
                 headers: {
                     'Content-Type': 'application/json;charset=utf-8'
                 },
                 body: JSON.stringify({
                     username: this.forgotPasswordUsername,
                     email: this.forgotPasswordEmail
                 })
             }).then((response) => {
                 if (response.ok) {
                     this.$buefy.toast.open({
                         duration: 3000,
                         message: "Password successfully reset. Please check your email",
                         position: 'is-bottom',
                         type: 'is-success',
                         queue: false
                     }); 
                 } else if (response.status === 404) {
                     this.$buefy.toast.open({
                         duration: 3000,
                         message: "We couldn't find a user with those credentials",
                         position: 'is-bottom',
                         type: 'is-danger',
                         queue: false
                     });
                 } else {
                     this.$buefy.toast.open({
                         duration: 3000,
                         message: "Something went wrong",
                         position: 'is-bottom',
                         type: 'is-danger',
                         queue: false
                     });
                 }
             }).catch((e) => {
                 console.error(e);
                 this.$buefy.toast.open({
                     duration: 3000,
                     message: "Something went wrong",
                     position: 'is-bottom',
                     type: 'is-danger',
                     queue: false
                 });
             });
         }
     }
 }
</script>
